
#if !defined(AFX_JPGVIEW_H__7F760EAC_F599_4D81_BC1A_1C4A4A03CF17__INCLUDED_)
#define AFX_JPGVIEW_H__7F760EAC_F599_4D81_BC1A_1C4A4A03CF17__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"

const WORD SOI = 0xD8FF;
const WORD APP0 = 0xE0FF;
const WORD APP1 = 0xE1FF;
const WORD APP2 = 0xE2FF;
const WORD APP3 = 0xE3FF;
const WORD APP4 = 0xE4FF;
const WORD APP5 = 0xE5FF;
const WORD APP6 = 0xE6FF;
const WORD APP7 = 0xE7FF;
const WORD APP8 = 0xE8FF;
const WORD APP9 = 0xE9FF;
const WORD APP10 = 0xEAFF;
const WORD APP11 = 0xEBFF;
const WORD APP12 = 0xECFF;
const WORD APP13 = 0xEDFF;
const WORD APP14 = 0xEEFF;
const WORD DQT = 0xDBFF;
const WORD DHT = 0xC4FF;
const WORD SOF0 = 0xC0FF;
const WORD SOS = 0xDAFF;
const WORD DRI = 0xDDFF;

struct APP0Struct {
	char JFIF[5];
	BYTE VerHi;
	BYTE VerLo;
	BYTE XYAspect;
	WORD XRes;
	WORD YRes;
};

struct CompInfo1 {
	BYTE Id;
	BYTE DFactor;
	BYTE QTable;
};

struct CompInfo2 {
	BYTE Id;
	BYTE HTable;
};

struct SOF0Struct {
	BYTE x;
	BYTE Precis;
	WORD Height;
	WORD Width;
	BYTE NumComp;
	CompInfo1 Comps[3];
};

struct SOSStruct {
	BYTE NumComp;
	CompInfo2 Comps[3];
};

struct HuffmanTable {
	BYTE Count[16];
	WORD TotalCount;
	BYTE Bytes[256];
};

struct RGB {
	BYTE b, g, r;
};

struct HTree {
	HTree *lnode;
	HTree *rnode;
	BYTE Byte;
	bool IsLeaf;
	HTree() 
	{ 
		lnode = rnode = NULL;
		IsLeaf = false;
	}
	~HTree()
	{
		if (lnode) delete lnode;
		if (rnode) delete rnode;
	}
};

struct DiscrInfo {
	int MaxHDiscr;
	int MaxVDiscr;
	int YBlocks;
	int CbBlocks;
	int CrBlocks;
	int BlockW;
	int BlockH;
	int BlockSize;
};

int TransposeTable[8][8] = 
{{ 0, 1, 5, 6,14,15,27,28},
 { 2, 4, 7,13,16,26,29,42},
 { 3, 8,12,17,25,30,41,43},
 { 9,11,18,24,31,40,44,53},
 {10,19,23,32,39,45,52,54},
 {20,22,33,38,46,51,55,60},
 {21,34,37,47,50,56,59,61},
 {35,36,48,49,57,58,62,63}};

#endif // !defined(AFX_JPGVIEW_H__7F760EAC_F599_4D81_BC1A_1C4A4A03CF17__INCLUDED_)
